#!/usr/bin/python

#Copyright (C) 2006 John 
#
#This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the #Free Software Foundation; either version 2 of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of #MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, #Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import urllib
import os
import sys
from qt import  *
import time
import signal
from xml.dom import minidom , getDOMImplementation

tempdir="/tmp/"


def homevar():
    if sys.platform=="win32":
          return os.environ.get('HOMEPATH')
    else:
	  return os.environ.get('HOME')

def writetvxml(): # Write TV List
    try: 
	tv=urllib.urlopen('http://www.shoutcast.com/sbin/tvlister.phtml?limit='\
                  +str(getmaxdl())+'&service=winamp3&no_compress=1')
    except IOError:
	print "Error Can't Access TV Stream List"
	return "-1"
    try:
	tvfile=open(homevar()+'/.tunapie/tvlist','w')
	tvfile.write(tv.read())
	tvfile.close()
    except:
	print "Can't Write TV File"
    
def writeradioxml(): # Write Radio List
    try: 
	radio=urllib.urlopen('http://www.shoutcast.com/sbin/xmllister.phtml?limit='\
                  +str(getmaxdl())+'&service=winamp2&no_compress=1')
    except IOError:
	print "Error Can't Access Radio Stream List"
	return "-1"
    try:
	radiofile=open(homevar()+'/.tunapie/radiolist','w')
	radiofile.write(radio.read())
	radiofile.close()
    except:
	print "Can't Write Radio File"
    
def getlist(tipo): # tipo=0 TV , tipo=1 Radio , tipo=2 Favorites
    if (tipo==0):
	    file="/.tunapie/tvlist"
    if (tipo==1):
	    file="/.tunapie/radiolist"
    if (tipo==2):
	    file="/.tunapie/favorites"
    stationurl=[]
    stationname=[]
    stationgenre=[]
    stationplaying=[]
    stationbitrate=[]
    stationlisteners=[]
    stationmod=[]
    f=open(homevar()+file,'r')
    pos=0
    oldpos=0
    data=f.read()
    while 1:
        url=data.find('Playstring="',pos)
        if(url==-1 or pos<oldpos):
            if(tipo!=2):
                return(stationurl,stationname,stationgenre,\
                          stationplaying,stationbitrate,stationlisteners)
            return(stationname,stationurl,stationgenre,stationplaying,\
                          stationbitrate,stationlisteners,stationmod)
        oldpos=pos
        urlend=data.find('&',pos)
        name=data.find('<Name>',pos)
        nameend=data.find('</Name>',pos)
        genre=data.find('<Genre>',pos)
        genreend=data.find('</Genre>',pos)
        playing=data.find('<Nowplaying>',pos)
        playingend=data.find('</Nowplaying>',pos)
        listeners=data.find('<Listeners>',pos)
        listenersend=data.find('</Listeners>',pos)
        bitrate=data.find('<Bitrate>',pos)
        bitrateend=data.find('</Bitrate>',pos)
        pos=bitrateend+10
	if getadultfilter() =="1":  # Adult Filter On
		if (tipo==0):
			 rating=data.find('<Rating',pos)
        		 ratingend=data.find('</Rating>',pos) 
			 if(data[rating+8:ratingend]=="NC17"):
				  continue
        if tipo==2:
            mod=data.find('<Mod>',pos)
            modend=data.find('</Mod>',pos)
            try: stationmod.append(int(data[mod+5:modend]))
            except ValueError:
                if (data[mod+5:modend]=='True'):
                    stationmod.append(1)
                else:
                    stationmod.append(0)
        if pos<oldpos:
            continue
        stationurl.append(data[url+12:urlend])
        stationname.append(data[name+6:nameend])
        stationgenre.append(data[genre+7:genreend])
        stationplaying.append(data[playing+12:playingend])
        stationlisteners.append(data[listeners+11:listenersend])
        stationbitrate.append(data[bitrate+9:bitrateend])

def playselection(mediaplayer,pls):
    tempor=tempdir + "temp.pls" # Tempdirectory + tempfile
    tempfile=open(tempor,'w')
    playlist=urllib.urlopen(pls)
    tempfile.write(playlist.read())
    #process=os.spawnv(os.P_NOWAIT,mediaplayer,[mediaplayer, tempor])
    process=os.system(mediaplayer +" " +tempor)
    return process

def playvid(pls):
    mediaplayer=getmediaplayer()
    try :
    	playlist=urllib.urlopen(pls)
    except :
	print "Error Can't Reach Server"
	return "-1"
    tempfile=playlist.read()
    url=tempfile[tempfile.find('//')+2:tempfile.find(';')]
    if sys.platform=="win32":
       mediaplayer="C:\\VLC\\vlc.exe"
       process=os.system(mediaplayer +' http://'+url)
    else :
       proceso=QProcess() # Open external program
       proceso.addArgument(mediaplayer);
       #proceso.addArgument( "-p" );
       proceso.addArgument( "http://"+url );
       print proceso
       if not proceso.start():
             # Error
	     print"Error"
	     
    return proceso

def savefavorites(favname,favurl,favlist,favplay,favbit,favgen,favmod):
    favfile=open(homevar()+'/.tunapie/favorites','w')
    for i in range(len(favname)):
        favfile.write('Playstring="'+favurl[i]+'&')
        favfile.write('<Name>'+favname[i]+'</Name>')
        favfile.write('<Genre>'+favgen[i]+'</Genre>')
        favfile.write('<Nowplaying>'+favplay[i]+'</Nowplaying>')
        favfile.write('<Listeners>'+favlist[i]+'</Listeners>')
        favfile.write('<Bitrate>'+favbit[i]+'</Bitrate>')
        favfile.write('<Mod>'+str(favmod[i])+'</Mod>')

def writepreferences(max,player,adult): # Write xml file
	xmldoc=getDOMImplementation().createDocument(None, "Preferences", None)
        ini_element = xmldoc.documentElement
	xmldoc.appendChild(ini_element)

	node = xmldoc.createElement("Max")
	ini_element.appendChild(node)
	value=xmldoc.createTextNode(str(max))
	node.appendChild(value)

	node = xmldoc.createElement("Player")
	ini_element.appendChild(node)
	value=xmldoc.createTextNode(str(player))
	node.appendChild(value)

	node = xmldoc.createElement("Adult")
	ini_element.appendChild(node)
	value=xmldoc.createTextNode(str(adult))
	node.appendChild(value)

	# Write XML file
	file=open(homevar()+'/.tunapie/pref','w')
	file.write(xmldoc.toxml())
	file.close()
	
	
def readpreferences(): # read xml file for preferences
	xmlfile=minidom.parse(homevar()+'/.tunapie/pref')
	print xmlfile.getElementsByTagName('Max')[0].firstChild.data
	print xmlfile.getElementsByTagName('Player')[0].firstChild.data
	print xmlfile.getElementsByTagName('Adult')[0].firstChild.data
	
def getmaxdl(): # Get Max Number of Streams
	try:
		xmlfile=minidom.parse(homevar()+'/.tunapie/pref')
	except IOError:
		writepreferences(500,"vlc",1)
	return xmlfile.getElementsByTagName('Max')[0].firstChild.data

def getmediaplayer(): # Get Media Player
	xmlfile=minidom.parse(homevar()+'/.tunapie/pref')
	return xmlfile.getElementsByTagName('Player')[0].firstChild.data

def getadultfilter(): # read xml file for preferences
	xmlfile=minidom.parse(homevar()+'/.tunapie/pref')
	return xmlfile.getElementsByTagName('Adult')[0].firstChild.data
